/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

Stack *stack_malloc (len)
{
	Stack *stack;

	stack = (Stack*) U_malloc (sizeof (Stack));
	stack->len = len;
	stack->current = -1;

	return stack;
}
	
stack_push (stack, ele)
Stack *stack;
char *ele;
{
	char **oldstack;
	int i;

	if (stack == (Stack*) 0)
		SYSERR;

	if (stack->top >= stack->size) {
		oldstack = stack->stack;

		stack->size = stack->size + stack->len;
		stack->stack = (char**) U_malloc (sizeof (char*) * stack->size);

		for (i = 0; i < stack->size - stack->len; i++)
			stack->stack [i] = oldstack [i];

		U_free (oldstack);
	}

	stack->stack [stack->top++] = ele;
}

stack_clear (stack)
Stack *stack;
{
	if (stack != (Stack*) 0)
		stack->top = 0;
}

char *stack_pop (stack)
Stack *stack;
{
	if (stack->top)
		return stack->stack [--stack->top];
	else
		return (char*) 0;
}

int stack_index (stack, ele)
Stack *stack;
char *ele;
{
	int i;

	for (i = 0; i < stack->top; i++)
		if (ele == stack->stack [i])
			return i;

	SYSERR;

	return stack->top-1;
}
